#-*- coding:utf-8 -*-

#  Copyright (C) 2009 B. Clausius
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 3 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.


# Ported from GNUbik
# Original filename: rand.scm
# Original copyright and license:
#;;   Copyright (c) 2004 Dale Mellor
#;;
#;;   This program is free software; you can redistribute it and/or modify
#;;   it under the terms of the GNU General Public License as published by
#;;   the Free Software Foundation; either version 3 of the License, or
#;;   (at your option) any later version.
#;;
#;;   This program is distributed in the hope that it will be useful,
#;;   but WITHOUT ANY WARRANTY; without even the implied warranty of
#;;   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#;;   GNU General Public License for more details.
#;;
#;;   You should have received a copy of the GNU General Public License
#;;   along with this program.  If not, see <http://www.gnu.org/licenses/>.


# Procedure which generates a list of lists of three random items, and sends it
# to gnubik-rotate-animated. The three random components are the face number
# (0, 1 or 2), the slice number (-(size-1), ..., size-3, size-1), and the
# direction to turn the slice (0 or 1).
def randomize(num):
    size = plugin_cube_state()[0][2]
    moves = [(random(3), 2*random(size) - (size-1), random(2)) for i in xrange(num)]
    plugin_rotate_animated(moves)

# Invoke the above procedure from a good few menu items for the convenience of
# the user.
scripts = [
        ('/'.join((_('Randomize'),_('%s Move animated') %1)), lambda: randomize(1)),
        ('/'.join((_('Randomize'),_('%s Moves animated')%2)), lambda: randomize(2)),
        ('/'.join((_('Randomize'),_('%s Moves animated')%3)), lambda: randomize(3)),
        ('/'.join((_('Randomize'),_('%s Moves animated')%4)), lambda: randomize(4)),
        ('/'.join((_('Randomize'),_('%s Moves animated')%5)), lambda: randomize(5)),
        ('/'.join((_('Randomize'),_('%s Moves animated')%6)), lambda: randomize(6)),
        ('/'.join((_('Randomize'),_('%s Moves animated')%7)), lambda: randomize(7)),
        ('/'.join((_('Randomize'),_('%s Moves animated')%8)), lambda: randomize(8)),

        ('/'.join((_('Randomize'),_('%s Moves') %50)), lambda: (randomize(50),  plugin_run_moves())),
        ('/'.join((_('Randomize'),_('%s Moves')%100)), lambda: (randomize(100), plugin_run_moves())),
        ('/'.join((_('Randomize'),_('%s Moves')%200)), lambda: (randomize(200), plugin_run_moves())),
    ]

